var scriptName		= "AutoBackup";
var scriptVersion	= "0.2a";
var scriptAuthor	= "vladsm@mail.ru";

String.prototype.d2 = function(){return this.replace(/^(\d)$/,'0$1')}
var AB = {
	defaultPeriod:5,
	defaultStages:1,
	params:{},
	dateObj:new Date(),
	pattern:/({last:(\d+)})/,
	makeTimeName:function(docName){
		var str = this.dateObj.getFullYear()+''+(this.dateObj.getMonth()+1).toString().d2()+''+this.dateObj.getDate().toString().d2()+''+this.dateObj.getHours().toString().d2()+''+this.dateObj.getMinutes().toString().d2()+''+this.dateObj.getSeconds().toString().d2();
		return docName.replace(/(\.[a-z]+)$/i,'$1.'+str+'.psd');
	},
	makeFileName:function (docFile,newName){
		return ((this.params.targetSame)?docFile.path:this.params.targetDir)+'/'+newName;
	},
	saveDocBackup:function(doc){
		var psdOptions = new PhotoshopSaveOptions();
		psdOptions.alphaChannels = true;
		psdOptions.annotations = true;
		psdOptions.embedColorProfile = true;
		psdOptions.layers = true;
		psdOptions.spotColors = true;
		try{
			var tf = new File(this.makeFileName(doc.fullName,this.makeTimeName(doc.name)));
			doc.saveAs(tf,psdOptions,true,Extension.LOWERCASE);
			tf.rename(tf.name.replace(/\.psd$/,'.bak'));
			this.deleteOldAutoBackupFiles(doc);
			return true;
		}
		catch(e){
			alert('Error!\n'+e); 
			return false;
		}
	},
	isAutoBackupOn:function(){
		return this.params.enabled;
	},
	itsTimeForBackup:function(doc,docTime){
	  	return (Math.ceil((parseInt(this.dateObj.valueOf())-parseInt(docTime))/60000)>parseInt(this.params.period));
	},
	getDocTime:function(doc){
		var as = doc.info.caption.match(this.pattern);
		if(as){	
			eval('po = '+as[1]+';');
			if(parseInt(po.last)==0){
				po.last=this.dateObj.valueOf();
			}
			return po.last;
		}else{
			if(this.isAutoBackupOn()){
				this.saveAutoBackupParams(doc,this.dateObj.valueOf());
			}
			return this.dateObj.valueOf();
		}
	},
	turnAutoBackupOff:function(doc){
		doc.info.caption = doc.info.caption.replace(/{last:\d+}/,'');
	},
	turnAutoBackupOn:function(doc,last){
		doc.info.caption+= '{last:'+last+'}';
	},
	saveAutoBackupParams:function(doc,last){
		if(as = doc.info.caption.match(this.pattern)){
			doc.info.caption = doc.info.caption.replace(/{last:\d+}/,'{last:'+last+'}');
		}else{
			this.turnAutoBackupOn(doc,last);
		}
	},
	deleteOldAutoBackupFiles:function(doc,nSave){
		var folder = new Folder((this.params.targetSame)?doc.fullName.path:this.params.targetDir);
		var mask = doc.name.replace(/(\.[a-z]+)$/,'$1.??????????????.bak');
		var fileList = folder.getFiles(mask);
		if(!nSave){
			nSave=this.defaultStages;
		}else if(nSave==-1){
			nSave=0;
		}
		for(i=0;i<(fileList.length-nSave);i++){
			try{var tf=new File(fileList[i]);tf.remove();}catch(e){}
		}
	},
	inspectThisDoc:function(doc){
		if(this.isAutoBackupOn()){
		 	var docTime = this.getDocTime(doc);
			if(this.itsTimeForBackup(doc,docTime)){
				if(this.saveDocBackup(doc)){
					this.saveAutoBackupParams(doc,this.dateObj.valueOf());
				}
			}
		}
	},
	main:function(){
		if(app.documents.length>0){
			this.inspectThisDoc(app.activeDocument);
		}
	}
}

var XP = {
	// a very crude xml parser, this reads the "Tag" of the <Tag>Data</Tag>
	readHeader:function( inFile ) {
		var returnValue = "";
		if(!inFile.eof){
			var c = "";
			while(c!="<" && !inFile.eof){
				c = inFile.read(1);
			}
			while(c!=">" && !inFile.eof){
				c = inFile.read(1);
				if(c!=">"){
					returnValue += c;
				}
			}
		}else{
			returnValue = "end of file";
		}
		return returnValue;
	},
	// very crude xml parser, this reads the "Data" of the <Tag>Data</Tag>
	readData:function(inFile){
		var returnValue = "";
		if(!inFile.eof){
			var c = "";
			while(c!="<" && !inFile.eof){
				c = inFile.read(1);
				if(c!="<"){
					returnValue += c;
				}
			}
			inFile.seek(-1,1);
		}
		return returnValue;
	},
	htmlspecialchars:function(strIn){
		strIn =''+strIn;
		reg_from = /&/g;
   		reg_to = "&amp;";
		var str = strIn.replace(reg_from, reg_to);
   		reg_from = /"/g;
		reg_to = "&quot;";
   		str = str.replace(reg_from, reg_to);
		reg_from = /'/g;
   		reg_to = "&#039;";
		str = str.replace(reg_from, reg_to);
   		reg_from = /</g;
		reg_to = "&lt;";
   		str = str.replace(reg_from, reg_to);
		reg_from = />/g;
   		reg_to = "&gt;";
		return str.replace(reg_from, reg_to);
	},
	unhtmlspecialchars:function(strIn){
		strIn =''+strIn;
		reg_from = /&gt;/g;
   		reg_to = ">";
		var str = strIn.replace(reg_from, reg_to);
   		reg_from = /&lt;/g;
		reg_to = "<";
		str = str.replace(reg_from, reg_to);
		reg_from = /&quot;/g;
		reg_to = '"';
		str = str.replace(reg_from, reg_to);
		reg_from = /&#039;/g;
   		reg_to = "'";
		str = str.replace(reg_from, reg_to);
		reg_from = /&amp;/g;
   		reg_to = "&";
		return str.replace(reg_from, reg_to);
	},
	getScriptNameForXML:function(scriptName){
		var scriptNameForXML = new String(scriptName);
		var charsToStrip = Array(" ","'",".","/","\\","<",">");
		for(var a=0;a<charsToStrip.length;a++){
			var nameArray = scriptNameForXML.split(charsToStrip[a]);
			scriptNameForXML = "";
			for(var b=0;b<nameArray.length;b++){
				scriptNameForXML += nameArray[b];
			}
		}
		return scriptNameForXML;
	},
	loadParams:function(loadFile,scriptName,paramObj){
		if(loadFile.exists){
			loadFile.open("r");
			var projectSpace = this.readHeader(loadFile);
			if(projectSpace==this.getScriptNameForXML(scriptName)){
				while(!loadFile.eof){
					var starter = this.readHeader(loadFile);
					var data = this.readData(loadFile);
					var ender = this.readHeader(loadFile);
					if(("/"+starter)==ender) {
						paramObj[starter] = this.unhtmlspecialchars(data);
					}
					// force boolean values to boolean types
					if ( data == "true" || data == "false" ) {
						paramObj[starter] = data == "true";
					}
				}
			}
			loadFile.close();
			return true;
		} 
		return false;
	},
	saveParams:function(saveFile,scriptName,paramObj){
		var fileName = saveFile.toString();
		if(!fileName.match(/\.xml$/i)){
			fileName = fileName+'.xml';
			saveFile = new File(fileName);
		}
		saveFile.encoding = "UTF8";
		saveFile.open("w","TEXT","????");
		// unicode signature, this is UTF16 but will convert to UTF8 "EF BB BF"
		saveFile.write("\uFEFF"); 
		var scriptNameForXML = this.getScriptNameForXML(scriptName);
		saveFile.writeln( "<"+scriptNameForXML+">");
		for(var p in paramObj){
			if(typeof(paramObj[p])!="object"){
				saveFile.writeln("\t<"+p+">"+this.htmlspecialchars(paramObj[p])+"</"+p+">");
			}
		}
		saveFile.writeln("</"+scriptNameForXML+">");
		saveFile.close();
		return true;
	},
	dump:function(obj){
		var msg = '';
		for(i in obj){
			try{msg+=i+':'+obj[i]+'\n'}catch(e){msg+=i+':'+e+'\n'}
		}
		return msg;
	}
}

